--- asterisk-13.11.0-rc1/res/res_pjsip/pjsip_configuration.c	2016-07-28 16:32:17.000000000 +0200
+++ asterisk-13_dev/res/res_pjsip/pjsip_configuration.c	2016-08-04 12:40:16.000000000 +0200
@@ -150,12 +150,14 @@
 	struct ast_sip_contact *contact;
 	enum ast_endpoint_state state = AST_ENDPOINT_OFFLINE;
 
-	/* If the status' aor isn't one of the endpoint's, we skip */
-	if (!strstr(persistent->aors, status->aor)) {
-		return 0;
-	}
+	if (status) {
+		/* If the status' aor isn't one of the endpoint's, we skip */
+		if (!strstr(persistent->aors, status->aor)) {
+			return 0;
+		}
 
-	endpoint_publish_contact_status(endpoint, status);
+		endpoint_publish_contact_status(endpoint, status);
+	}
 
 	/* Find all the contacts for this endpoint.  If ANY are available,
 	 * mark the endpoint as ONLINE.
@@ -1256,7 +1258,11 @@
 
 		persistent->aors = ast_strdup(endpoint->aors);
 
-		ast_endpoint_set_state(persistent->endpoint, AST_ENDPOINT_UNKNOWN);
+		if (ast_strlen_zero(persistent->aors)) {
+			ast_endpoint_set_state(persistent->endpoint, AST_ENDPOINT_UNKNOWN);
+		} else {
+			persistent_endpoint_update_state(persistent, NULL, 0);
+		}
 
 		ao2_link_flags(persistent_endpoints, persistent, OBJ_NOLOCK);
 	}
